online_food/config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  ActiveAdmin.routes(self)
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  root 'shops#index'
  resources :shops, only: [:index,:show]
  resources	:dishes, only: [:show]

end

online_food/app/models/adapters/only_admins.rb
class Adapters::OnlyAdmins < ActiveAdmin::AuthorizationAdapter

  def authorized?(action, subject = nil)
    user.admin?
  end

end

online_food/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

online_food/app/models/dish.rb
class Dish < ApplicationRecord
	belongs_to :shop
	has_one_attached :picture
end

online_food/app/models/shop.rb
class Shop < ApplicationRecord
	has_many :dishes
	has_one_attached :picture
end

online_food/app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

	validates :name, presence: true, length:{
		maximum: 50
	}

	validates :phone, presence: true, length:{
		maximum: 20
	}

	validates :address, presence: true, length:{
		maximum: 255
	}
end

online_food/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

	before_action :configure_permitted_parameters, if: :devise_controller?
	
	def access_denied(exception)
		flash[:danger] = exception.message
		redirect_to root_url
	end

	private

	def configure_permitted_parameters
		devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :phone, :address])
		devise_parameter_sanitizer.permit(:account_update, keys: [:name, :phone, :address])
	end
end

online_food/app/controllers/dishes_controller.rb
class DishesController < ApplicationController
	
end

online_food/app/controllers/shops_controller.rb
class ShopsController < ApplicationController

	def index
		@shops = Shop.all
	end

	def show
		dishes = Dish.all
		@shop = Shop.find(params[:id])
		@dishes = @shop.dishes
	end


end

online_food/app/helpers/application_helper.rb
module ApplicationHelper
end

online_food/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>OnlineFood</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="#">"Online-Food"</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active">
         <%= link_to 'Заведения', shops_path, class: 'nav-link' %>
       </li>
     </ul>

     <div class="navbar-nav ml-auto">
      <div class="navbar-nav ml-auto">
        <% if user_signed_in? %>
        <div class="nav-item">
          <span class="navbar-text">
            Hello, &nbsp;
          </span>
        </div>

        <div class="dropdown show">
          <%= link_to current_user.name, edit_user_registration_path(current_user), class: 'btn btn-secondary dropdown-toggle', 'role' => "button", 'id' => "dropdownMenuLink", 'data-toggle' => "dropdown", 'aria-haspopup' => "true", 'aria-expanded' => "false" %>
          <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
            <%= link_to 'Edit profile', edit_user_registration_path(current_user), class: 'dropdown-item' %>
            <%= link_to 'Sign out', destroy_user_session_path, method: :delete, class: 'dropdown-item' %>
          </div>
          <div>
            <% else %>
            <div class="nav-item">
             <%= link_to 'Sign up', new_user_registration_path, class: 'nav-link' %>
           </div>
           <div class="nav-item">
             <%= link_to 'Log in', new_user_session_path, class: 'nav-link' %>
           </div>
           <% end %>
         </div>
       </div>
     </div>
   </div>
 </div>
</nav>

<div class="container">
  <%= yield %>
</div>
</body>
</html>

online_food/app/views/shops/index.html.erb
<div class="row justify-content-start mt-3">
  <% @shops.each do |shop| %>
  <div class="col-sm m-3">
    <div class="card" style="width: 18rem;">
      <%= image_tag shop.picture, class:"card-img-top" , size: 150%>
      <div class="card-body text-center">
        <h5 class="card-title text-uppercase"><%= shop.title %></h5>
        <%= link_to "Просмотреть", shop, class:"btn btn-primary" %>
      </div>  
    </div>
  </div>
  <% end %>
</div>

online_food/app/views/shops/show.html.erb
<div class="d-flex justify-content-start m-3">
	<div>
		<%= image_tag @shop.picture, size: '200' %>
	</div>
	<div>
		<h1 class="display-4 pl-2"><%=@shop.title%></h1>
		<p class="lead pl-3"><%= @shop.description %></p>
	</div>
</div>

<div class="row">
	<% @dishes.each do |dish| %>
	<div class="col-sm">
		<div class="card" style="width: 16rem;">
			<%= image_tag dish.picture, class:"card-img-top" , size: '150' %>
			<div class="card-body text-center">
				<h5 class="card-title"><%= dish.title %></h5>
				<p class="card-text"><%= dish.description %></p>
				<p class="card-text"><%= dish.price %> c</p>
			</div>
		</div>
	</div>
	<% end %>
</div>